 ; Water - write a lisp file to create a series of grdraw vectors using
 ; selected lines as a pattern.
 ; Copyright 1995 by Rocket Software
 ; How to explode text (or anything): a tutorial.
 ; 1. Add the Dxb writer to your plotter configuration.
 ; 2. Plot the desired entities to a dxb file.
 ; 3. Dxbin the file.  This gives you the original entities as lines.


 (DEFUN ABSOLU (fn lspnam / ss num entt ten elv llist len sub)
  (write-line "Select lines: ")
  (setq ss (ssget (list (cons 0 "LINE"))))
  (setq num 0)
  (while (and ss (setq entt (ssname ss num)))
         (setq entt (entget entt))
         (setq num (1+ num))
         (setq ten (cdr (assoc 10 entt)))
         (setq elv (cdr (assoc 11 entt)))
         (setq llist (append llist (list (list ten elv)))))
  (write-line (strcat " (DEFUN C:" lspnam " (/ grlist num sub)") fn)
  (write-line "  (setq grlist (list " fn)
  (setq len (length llist))
  (setq num 0)
  (while (setq sub (nth num llist))
         (setq num (1+ num))
         (write-line (strcat "  '((" (rtos (caar sub)) " "
                                     (rtos (cadar sub)) ") "
                                "(" (rtos (caadr sub)) " "
                                    (rtos (cadadr sub)) "))"
                             (if (= num len) "))" "")) fn))
  (write-line "  (setq num 0)" fn)
  (write-line "  (while (setq sub (nth num grlist))" fn)
  (write-line "         (grdraw (car sub) (cadr sub) -1)" fn)
  (write-line "         (setq num (1+ num)))" fn)
  (write-line " (princ))" fn)
  (close fn)
 (princ))


 (DEFUN RELATI (fn lspnam / scrsz vwhr vhh ctr hwid minx miny ss num entt ten
                         elv llist prevhx prevhy xratio yratio grlist len sub)
 ; Find out where the current view is, and how big.
  (setq scrsz (getvar "screensize"))       ; view height & width (pixels)
  (setq vwhr (/ (car scrsz) (cadr scrsz))) ; view width/height ratio
  (setq vhh (* (getvar "viewsize") 0.5))   ; view half height in drawing units
  (setq ctr (getvar "viewctr"))            ; centre point of screen
  (setq hwid (* vhh vwhr))                 ; view half width
  (setq minx (- (car ctr) hwid))
  (setq miny (- (cadr ctr) vhh))
 ; Now ask for pattern lines.
  (write-line "Select lines: ")
  (setq ss (ssget (list (cons 0 "LINE"))))
  (setq num 0)
  (while (and ss (setq entt (ssname ss num)))
         (setq entt (entget entt))
         (setq num (1+ num))
         (setq ten (cdr (assoc 10 entt)))
         (setq elv (cdr (assoc 11 entt)))
 ; Change points to offset from lower left of current view.
         (setq ten (list (- (car ten) minx) (- (cadr ten) miny)))
         (setq elv (list (- (car elv) minx) (- (cadr elv) miny)))
 ; And add them to the list.
         (setq llist (append llist (list (list ten elv)))))
  (write-line (strcat " (DEFUN C:" lspnam
         " (/ prevhx prevhy scrsz vwhr ctr vhh hwid xratio yratio minx") fn)
  (write-line (strcat "                                                  "
                      "miny grlist num sub ten elv)") fn)
  (write-line (strcat "  (setq prevhx " (rtos hwid 2) ")") fn)
  (write-line (strcat "  (setq prevhy " (rtos vhh 2) ")") fn)
  (write-line "  (setq scrsz (getvar \"screensize\"))" fn)
  (write-line "  (setq vwhr (/ (car scrsz) (cadr scrsz)))" fn)
  (write-line "  (setq ctr (getvar \"viewctr\"))" fn)
  (write-line "  (setq vhh (* (getvar \"viewsize\") 0.5))" fn)
  (write-line "  (setq hwid (* vhh vwhr))" fn)
  (write-line "  (setq xratio (/ hwid prevhx))" fn)
  (write-line "  (setq yratio (/ vhh prevhy))" fn)
  (write-line "  (setq minx (- (car ctr) hwid))" fn)
  (write-line "  (setq miny (- (cadr ctr) vhh))" fn)
  (write-line "  (setq grlist (list " fn)
  (setq len (length llist))
  (setq num 0)
 ; Make the points list.
  (while (setq sub (nth num llist))
         (setq num (1+ num))
         (write-line (strcat "  '((" (rtos (caar sub) 2) " "
                                     (rtos (cadar sub) 2) ") "
                                "(" (rtos (caadr sub) 2) " "
                                    (rtos (cadadr sub) 2) "))"
                             (if (= num len) "))" "")) fn))
 ; And write the list interpreter code.
  (write-line "  (setq num 0)" fn)
  (write-line "  (while (setq sub (nth num grlist))" fn)
  (write-line "         (setq ten (car sub))" fn)
  (write-line "         (setq elv (cadr sub))" fn)
  (write-line "         (setq ten (list (+ (* xratio (car ten)) minx)" fn)
  (write-line "                         (+ (* yratio (cadr ten)) miny)))" fn)
  (write-line "         (setq elv (list (+ (* xratio (car elv)) minx)" fn)
  (write-line "                         (+ (* yratio (cadr elv)) miny)))" fn)
  (write-line "         (grdraw ten elv -1)" fn)
  (write-line "         (setq num (1+ num)))" fn)
  (write-line " (princ))" fn)
  (close fn)
 (princ))


 (DEFUN C:WATER (/ filnam ll ch lspnam quipt handle insp)
  (setq filnam (getstring "\nLisp name <Fdap>: "))
  (if (= filnam "") (setq filnam "fdap.lsp"))
 ; See if the file name includes an extension.
  (setq ll (strlen filnam))
  (while (and (null ch) (< 0 ll) (/= (substr filnam ll 1) (chr 92)))
         (if (= (substr filnam ll 1) ".")
             (setq ch T))
         (setq ll (1- ll)))
 ; Make filename and lispname.
  (if (null ch)
      (progn
           (setq lspnam filnam)
           (setq filnam (strcat filnam ".lsp")))
      (setq lspnam (substr filnam 1 ll)))
 ; See if the file exists.
  (if (findfile filnam)
      (progn
           (initget 0 "Overwrite Append Quit")
           (setq quipt (getkword (strcat
                         "That file already exists."
                         "  Overwrite, Append, or <Quit>? ")))
           (if (null quipt) (setq quipt "Quit"))))
  (cond ((or (null quipt)
             (= quipt "Append"))
         (setq handle (open filnam "a"))
         (if (null handle)
             (write-line "Unable to open that file")))
        ((= quipt "Overwrite")
         (setq handle (open filnam "w"))
         (close handle)
         (setq handle (open filnam "a"))
         (if (null handle)
             (write-line "Unable to open that file")))
        ((= quipt "Quit")
         (setq handle ())))
 ; Ask how to write Lisp file.
  (initget 0 "Relative Absolute")
  (if handle
      (progn
           (Setq insp (getkword "Draw vectors Absolute/<Relative>: "))
           (if (or (null insp) (= insp "Relative"))
               (relati handle lspnam)
               (absolu handle lspnam))))
 (princ))